Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/LogicalExpression.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/LogicalExpression.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/LogicalExpression.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,14 +38,8 @@
 
     [StorableConstructor]
-    private LogicalExpression(bool deserializing) : base(deserializing) { }
-    private LogicalExpression(LogicalExpression original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected LogicalExpression(bool deserializing) : base(deserializing) { }
+    protected LogicalExpression(LogicalExpression original, Cloner cloner) : base(original, cloner) { }
 
-    public LogicalExpression()
-      : base("LogicalExpression", "A LogicalExpression.") {
-      this.Prefix = "";
-      this.Suffix = "";
-    }
+    public LogicalExpression() : base("LogicalExpression", "A logical expression.") { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -52,21 +47,20 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
       var enumerator = children.GetEnumerator();
+      if (!enumerator.MoveNext()) throw new System.Exception("LogicalExpression was not given a child.");
 
-      if (!enumerator.MoveNext()) throw new System.Exception("LogicalExpression was not given a child.");
       var symbol = enumerator.Current.Symbol;
-
-      if (!(symbol is LogicalValue || symbol is LogicalComparison ||
-          symbol is NumericalComparison || symbol is Negation))
-        throw new System.Exception("LogicalExpression was given a child of type " + symbol.GetType().ToString() +
-            ". The expected child must be of type " + typeof(LogicalValue).ToString() + " or " +
-            typeof(LogicalComparison).ToString() + " or " + typeof(NumericalComparison).ToString() + " or " +
-            typeof(Negation).ToString() + ".");
+      if (!(symbol is LogicalValue || symbol is Conjunction || symbol is Disjunction || symbol is Negation))
+        throw new System.Exception("LogicalExpression was given a child of type " + symbol.GetType() +
+            ". The expected child must be of type " + typeof(LogicalValue)
+                                           + " or " + typeof(Conjunction)
+                                           + " or " + typeof(Disjunction)
+                                           + " or " + typeof(Negation) + ".");
 
       string result = ((CodeNode)symbol).Interpret(enumerator.Current, enumerator.Current.Subtrees);
       if (enumerator.MoveNext()) throw new System.Exception("LogicalExpression was given more than one child.");
 
-      return this.Prefix + result + this.Suffix;
+      return result;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/LogicalValue.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/LogicalValue.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/LogicalValue.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,17 +38,10 @@
 
     [StorableConstructor]
-    private LogicalValue(bool deserializing) : base(deserializing) { }
-    private LogicalValue(LogicalValue original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected LogicalValue(bool deserializing) : base(deserializing) { }
+    protected LogicalValue(LogicalValue original, Cloner cloner) : base(original, cloner) { }
 
-    public LogicalValue()
-      : base("LogicalValue", "A LogicalValue.") {
-      this.Prefix = "";
-      this.Suffix = "";
-    }
+    public LogicalValue() : base("LogicalValue", "A logical value.") { }
 
     public override ISymbolicExpressionTreeNode CreateTreeNode() {
-
       return new BooleanTreeNode();
     }
@@ -57,6 +51,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return " " + ((BooleanTreeNode)node).Value.ToString().ToLower() + " ";
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return ((BooleanTreeNode)node).Value.ToString().ToLower();
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Negation.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Negation.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Logical Expressions/Negation.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,13 +38,11 @@
 
     [StorableConstructor]
-    private Negation(bool deserializing) : base(deserializing) { }
-    private Negation(Negation original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected Negation(bool deserializing) : base(deserializing) { }
+    protected Negation(Negation original, Cloner cloner) : base(original, cloner) { }
 
     public Negation()
-      : base("Negation", "A Negation.") {
-      this.Prefix = "!(";
-      this.Suffix = ")";
+      : base("Negation", "A negation.") {
+      Prefix = "!(";
+      Suffix = ")";
     }
 
@@ -52,20 +51,21 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
       var enumerator = children.GetEnumerator();
       if (!enumerator.MoveNext()) throw new System.Exception("Negation was not given a child.");
 
       var symbol = enumerator.Current.Symbol;
-      if (!(symbol is LogicalValue || symbol is LogicalComparison ||
-          symbol is NumericalComparison || symbol is Negation))
-        throw new System.Exception("Negation was given a child of type " + symbol.GetType().ToString() +
-            ". The expected child must be of type " + typeof(LogicalValue).ToString() + " or " +
-            typeof(LogicalComparison).ToString() + " or " + typeof(NumericalComparison).ToString() + " or " +
-            typeof(Negation).ToString() + ".");
+      if (!(symbol is LogicalValue || symbol is Conjunction || symbol is Disjunction || symbol is Negation || symbol is ILogicalComparator))
+        throw new System.Exception("Negation was given a child of type " + symbol.GetType() +
+            ". The expected child must be of type " + typeof(LogicalValue)
+                                           + " or " + typeof(Conjunction)
+                                           + " or " + typeof(Disjunction)
+                                           + " or " + typeof(Negation)
+                                           + " or " + typeof(ILogicalComparator) + ".");
 
       string result = ((CodeNode)symbol).Interpret(enumerator.Current, enumerator.Current.Subtrees);
       if (enumerator.MoveNext()) throw new System.Exception("LogicalExpression was given more than one child.");
 
-      return this.Prefix + result + this.Suffix;
+      return Prefix + result + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Number.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Number.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Number.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,17 +38,10 @@
 
     [StorableConstructor]
-    private Number(bool deserializing) : base(deserializing) { }
-    private Number(Number original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected Number(bool deserializing) : base(deserializing) { }
+    protected Number(Number original, Cloner cloner) : base(original, cloner) { }
 
-    public Number()
-      : base("Number", "A Number.") {
-      this.Prefix = "";
-      this.Suffix = "";
-    }
+    public Number() : base("Number", "A number.") { }
 
     public override ISymbolicExpressionTreeNode CreateTreeNode() {
-
       return new NumberTreeNode();
     }
@@ -57,6 +51,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return " " + ((NumberTreeNode)node).Value + " ";
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return ((NumberTreeNode)node).Value.ToString();
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/NumberTreeNode.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/NumberTreeNode.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/NumberTreeNode.cs	(revision 10011)
@@ -36,13 +36,11 @@
 
     [StorableConstructor]
-    private NumberTreeNode(bool deserializing) : base(deserializing) { }
-    private NumberTreeNode(NumberTreeNode original, Cloner cloner)
+    protected NumberTreeNode(bool deserializing) : base(deserializing) { }
+    protected NumberTreeNode(NumberTreeNode original, Cloner cloner)
       : base(original, cloner) {
       this.value = original.value;
     }
 
-    public NumberTreeNode()
-      : base(new Number()) {
-    }
+    public NumberTreeNode() : base(new Number()) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Addition.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Addition.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Addition.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +29,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class Addition : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class Addition : CodeNode, INumericalOperator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return byte.MaxValue; } }
 
     [Storable]
@@ -37,14 +40,11 @@
 
     [StorableConstructor]
-    private Addition(bool deserializing) : base(deserializing) { }
-    private Addition(Addition original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected Addition(bool deserializing) : base(deserializing) { }
+    protected Addition(Addition original, Cloner cloner) : base(original, cloner) { }
 
     public Addition()
       : base("Addition", "Addition operator.") {
-      this.Prefix = "+";
-      this.Suffix = "";
+      Prefix = "(";
+      Suffix = ")";
     }
 
@@ -53,6 +53,10 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      if (children.Count() < 2)
+        throw new ArgumentException("Expected at leaset 2 children.", "children");
+
+      string result = string.Join(" + ", children.Select(c => ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Division.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Division.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Division.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +29,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class Division : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class Division : CodeNode, INumericalOperator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return byte.MaxValue; } }
 
     [Storable]
@@ -37,14 +40,11 @@
 
     [StorableConstructor]
-    private Division(bool deserializing) : base(deserializing) { }
-    private Division(Division original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected Division(bool deserializing) : base(deserializing) { }
+    protected Division(Division original, Cloner cloner) : base(original, cloner) { }
 
     public Division()
       : base("Division", "Division operator.") {
-      this.Prefix = "/";
-      this.Suffix = "";
+      Prefix = "(";
+      Suffix = ")";
     }
 
@@ -53,6 +53,10 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      if (children.Count() < 2)
+        throw new ArgumentException("Expected at leaset 2 children.", "children");
+
+      string result = string.Join(" / ", children.Select(c => ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/INumericalOperator.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/INumericalOperator.cs	(revision 10011)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/INumericalOperator.cs	(revision 10011)
@@ -0,0 +1,24 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Robocode {
+  public interface INumericalOperator { }
+}
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Modulus.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Modulus.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Modulus.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +29,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class Modulus : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class Modulus : CodeNode, INumericalOperator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return byte.MaxValue; } }
 
     [Storable]
@@ -37,14 +40,11 @@
 
     [StorableConstructor]
-    private Modulus(bool deserializing) : base(deserializing) { }
-    private Modulus(Modulus original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected Modulus(bool deserializing) : base(deserializing) { }
+    protected Modulus(Modulus original, Cloner cloner) : base(original, cloner) { }
 
     public Modulus()
       : base("Modulus", "Modulus operator.") {
-      this.Prefix = "%";
-      this.Suffix = "";
+      Prefix = "(";
+      Suffix = ")";
     }
 
@@ -53,6 +53,10 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      if (children.Count() < 2)
+        throw new ArgumentException("Expected at leaset 2 children.", "children");
+
+      string result = string.Join(" % ", children.Select(c => ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Multiplication.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Multiplication.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Multiplication.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +29,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class Multiplication : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class Multiplication : CodeNode, INumericalOperator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return byte.MaxValue; } }
 
     [Storable]
@@ -37,14 +40,11 @@
 
     [StorableConstructor]
-    private Multiplication(bool deserializing) : base(deserializing) { }
-    private Multiplication(Multiplication original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected Multiplication(bool deserializing) : base(deserializing) { }
+    protected Multiplication(Multiplication original, Cloner cloner) : base(original, cloner) { }
 
     public Multiplication()
       : base("Multiplication", "Multiplication operator.") {
-      this.Prefix = "*";
-      this.Suffix = "";
+      Prefix = "(";
+      Suffix = ")";
     }
 
@@ -53,6 +53,10 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      if (children.Count() < 2)
+        throw new ArgumentException("Expected at leaset 2 children.", "children");
+
+      string result = string.Join(" * ", children.Select(c => ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Subtraction.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Subtraction.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/Numerical Operators/Subtraction.cs	(revision 10011)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -26,7 +29,7 @@
 namespace HeuristicLab.Problems.Robocode {
   [StorableClass]
-  public class Subtraction : CodeNode {
-    public override int MinimumArity { get { return 0; } }
-    public override int MaximumArity { get { return 0; } }
+  public class Subtraction : CodeNode, INumericalOperator {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return byte.MaxValue; } }
 
     [Storable]
@@ -37,14 +40,11 @@
 
     [StorableConstructor]
-    private Subtraction(bool deserializing) : base(deserializing) { }
-    private Subtraction(Subtraction original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected Subtraction(bool deserializing) : base(deserializing) { }
+    protected Subtraction(Subtraction original, Cloner cloner) : base(original, cloner) { }
 
     public Subtraction()
       : base("Subtraction", "Subtraction operator.") {
-      this.Prefix = "-";
-      this.Suffix = "";
+      Prefix = "(";
+      Suffix = ")";
     }
 
@@ -53,6 +53,10 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      if (children.Count() < 2)
+        throw new ArgumentException("Expected at leaset 2 children.", "children");
+
+      string result = string.Join(" - ", children.Select(c => ((CodeNode)c.Symbol).Interpret(c, c.Subtrees)));
+      return Prefix + result + Suffix;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/NumericalExpression.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/NumericalExpression.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/NumericalExpression.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,14 +38,8 @@
 
     [StorableConstructor]
-    private NumericalExpression(bool deserializing) : base(deserializing) { }
-    private NumericalExpression(NumericalExpression original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected NumericalExpression(bool deserializing) : base(deserializing) { }
+    protected NumericalExpression(NumericalExpression original, Cloner cloner) : base(original, cloner) { }
 
-    public NumericalExpression()
-      : base("NumericalExpression", "A NumericalExpression.") {
-      this.Prefix = "";
-      this.Suffix = "";
-    }
+    public NumericalExpression() : base("NumericalExpression", "A numerical expression.") { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -52,20 +47,19 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
       var enumerator = children.GetEnumerator();
+      if (!enumerator.MoveNext()) throw new System.Exception("NumericalExpression was not given a child.");
 
-      if (!enumerator.MoveNext()) throw new System.Exception("NumericalExpression was not given a child.");
       var symbol = enumerator.Current.Symbol;
-
-      if (!(symbol is Number || symbol is NumericalOperation || symbol.GetType().GetInterface(typeof(INumericalMethod).FullName) != null))
-        throw new System.Exception("NumericalExpression was given a child of type " + symbol.GetType().ToString() +
-            ". The expected child must be of type " + typeof(Number).ToString() + " or " +
-            typeof(NumericalOperation).ToString() + " or " +
-            typeof(INumericalMethod).ToString() + ".");
+      if (!(symbol is Number || symbol is INumericalMethod || symbol is INumericalOperator))
+        throw new System.Exception("NumericalExpression was given a child of type " + symbol.GetType() +
+            ". The expected child must be of type " + typeof(Number)
+                                           + " or " + typeof(INumericalMethod)
+                                           + " or " + typeof(INumericalOperator) + ".");
 
       string result = ((CodeNode)symbol).Interpret(enumerator.Current, enumerator.Current.Subtrees);
       if (enumerator.MoveNext()) throw new System.Exception("NumericalExpression was given more than one child.");
 
-      return this.Prefix + result + this.Suffix;
+      return result;
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/ShotPower.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/ShotPower.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/ShotPower.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -37,12 +38,8 @@
 
     [StorableConstructor]
-    private ShotPower(bool deserializing) : base(deserializing) { }
-    private ShotPower(ShotPower original, Cloner cloner)
-      : base(original, cloner) {
-    }
+    protected ShotPower(bool deserializing) : base(deserializing) { }
+    protected ShotPower(ShotPower original, Cloner cloner) : base(original, cloner) { }
 
-    public ShotPower()
-      : base("ShotPower", "The power of a shot between 0.1 and 3.") {
-    }
+    public ShotPower() : base("ShotPower", "The power of a shot between 0.1 and 3.") { }
 
     public override ISymbolicExpressionTreeNode CreateTreeNode() {
@@ -54,6 +51,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return " " + ((ShotPowerTreeNode)node).Value + " ";
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return ((ShotPowerTreeNode)node).Value.ToString();
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/ShotPowerTreeNode.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/ShotPowerTreeNode.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Expressions/ShotPowerTreeNode.cs	(revision 10011)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -36,13 +37,11 @@
 
     [StorableConstructor]
-    private ShotPowerTreeNode(bool deserializing) : base(deserializing) { }
-    private ShotPowerTreeNode(ShotPowerTreeNode original, Cloner cloner)
+    protected ShotPowerTreeNode(bool deserializing) : base(deserializing) { }
+    protected ShotPowerTreeNode(ShotPowerTreeNode original, Cloner cloner)
       : base(original, cloner) {
       this.value = original.value;
     }
 
-    public ShotPowerTreeNode()
-      : base(new ShotPower()) {
-    }
+    public ShotPowerTreeNode() : base(new ShotPower()) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -55,5 +54,5 @@
 
     public override void ResetLocalParameters(IRandom random) {
-      value = (double)random.Next(1, 3);
+      value = Math.Max(0.1, random.NextDouble() * 3);
     }
   }
Index: branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetEnergy.cs
===================================================================
--- branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetEnergy.cs	(revision 10008)
+++ branches/Robocode.TrunkInt/HeuristicLab.Problems.Robocode/3.3/Symbols/Numerical Methods/GetEnergy.cs	(revision 10011)
@@ -20,5 +20,5 @@
 #endregion
 
-
+using System.Collections.Generic;
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
@@ -38,14 +38,11 @@
 
     [StorableConstructor]
-    private GetEnergy(bool deserializing) : base(deserializing) { }
-    private GetEnergy(GetEnergy original, Cloner cloner)
-      : base(original, cloner) {
-
-    }
+    protected GetEnergy(bool deserializing) : base(deserializing) { }
+    protected GetEnergy(GetEnergy original, Cloner cloner) : base(original, cloner) { }
 
     public GetEnergy()
       : base("GetEnergy", "Returns the robot's current energy.") {
-      this.Prefix = "getEnergy(";
-      this.Suffix = ")";
+      Prefix = "getEnergy(";
+      Suffix = ")";
     }
 
@@ -54,6 +51,6 @@
     }
 
-    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
-      return this.Prefix + this.Suffix;
+    public override string Interpret(ISymbolicExpressionTreeNode node, IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return Prefix + Suffix;
     }
   }
